<template>
  <div class="px-5">
    <v-row justify="center" class="mt-2 grey lighten-3 pa-12">
      <v-col cols="12" class="white">
        <v-card class="card d-flex flex-wrap mx-3" color="primary" dark>
          <v-col class="text-center" cols="12">
            <span class="subtitle-1">
              EMPLOYEE INFORMATION
            </span>
          </v-col>
        </v-card>
        <v-form
          ref="form"
          v-model="valid"
          lazy-validation
        >
          <LeaveField
            v-bind.sync="leave"
          >
          </LeaveField>
          <v-container class="py-0">
            <v-row justify="center">
              <v-col cols="12" sm="6" md="4">
                <v-text-field
                  dense
                  flat
                  outlined
                  :value="employeecode"
                  :counter="8"
                  :rules="codeRules"
                  label="Employee Code"
                   @change="$emit('update:employeecode', $event)"
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" sm="6" md="4">
                <v-select
                  dense
                  flat
                  outlined
                  :value="gender"
                  :items="genderitems"
                  :rules="[v => !!v || 'Gender is required']"
                  label="Gender"
                  @change="$emit('update:gender', $event)"
                ></v-select>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" sm="6" md="4">
                <v-select
                  dense
                  flat
                  outlined
                  :value="department"
                  :items="departmentitems"
                  :rules="[v => !!v || 'department is required']"
                  label="Departement"
                  @change="$emit('update:department', $event)"
                ></v-select>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" sm="6" md="4">
                <v-text-field
                  dense
                  flat
                  outlined
                  :value="firstname"
                  :rules="nameRules"
                  label="First Name"
                  @change="$emit('update:firstname', $event)"
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" sm="6" md="4">
                <v-text-field
                  dense
                  flat
                  outlined
                  :value="lastname"
                  :rules="nameRules"
                  label="Last Name"
                  @change="$emit('update:lastname', $event)"
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" sm="6" md="4">
                <v-menu
                  v-model="menu2"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  transition="scale-transition"
                  offset-y
                  min-width="290px"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      dense
                      flat
                      outlined
                      :value="DOB"
                      label="Date of birth"
                      prepend-icon="mdi-event"
                      readonly
                      v-bind="attrs"
                      v-on="on"
                      @change="$emit('update:DOB', $event)"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    @change="$emit('update:DOB', $event)"
                    :value="DOB"
                    @input="menu2 = false">
                  </v-date-picker>
                </v-menu>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" md="6">
                <v-text-field
                  dense
                  flat
                  outlined
                  :value="address"
                  :counter="100"
                  :rules="addressRules"
                  label="Address"
                  @change="$emit('update:address', $event)"
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" md="6">
                <v-text-field
                  dense
                  flat
                  outlined
                  :disabled="disabled"
                  :value="email"
                  :rules="emailRules"
                  label="Email"
                  @change="$emit('update:email', $event)"
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" sm="6">
                <v-text-field
                  dense
                  flat
                  outlined
                  :value="country"
                  :rules="countryRules"
                  label="Country"
                  @change="$emit('update:country', $event)"
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" sm="6">
                <v-text-field
                  dense
                  flat
                  outlined
                  :value="city"
                  :rules="cityRules"
                  label="City/Town"
                  @change="$emit('update:city', $event)"
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col v-if="visible" cols="12" sm="6">
                <v-text-field
                  dense
                  flat
                  v-if="visible"
                  outlined
                  v-model="password"
                  :rules="passwordRules"
                  label="Password"
                  required
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col v-if="visible" cols="12" sm="6">
                <v-text-field
                  dense
                  flat
                  v-if="visible"
                  outlined
                  v-model="password2"
                  :rules="password2Rules"
                  label="confirm password"
                  required
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  dense
                  flat
                  outlined
                  type="number"
                  :value="mobilenumber"
                  :counter="10"
                  :rules="mobileRules"
                  label="Mobile number"
                  @change="$emit('update:mobilenumber', $event)"
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" class="mt-5 text-center">
                <v-btn
                  :disabled="!valid"
                  :loading="loading"
                  color="secoundary"
                  class="mr-4 mb-2 white--text"
                  v-on:click="validate"
                >
                  Submit
                </v-btn>
                <v-btn
                  color="warning"
                  class="mb-2"
                  v-on:click="cancel"
                >
                  Cancel
                </v-btn>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-col>
    </v-row>
  </div>
</template>
<script>
import { getDepartmentList } from '@/firebase/db';
import LeaveField from '@/components/employeeForm/LeaveField.vue';
import Leave from '@/models/Leave';
// import { getAuthenticatedUser } from '@/fb';

export default {
  components: {
    LeaveField,
  },
  data() {
    return {
      leave: new Leave(),
      show: false,
      menu2: false,
      valid: true,
      password: '',
      password2: '',
      date: new Date().toISOString().substr(0, 10),
      codeRules: [
        (v) => !!v || 'code is required',
        (v) => (v && v.length <= 8) || 'Name must be less than 8 characters',
      ],
      genderitems: [
        'Male',
        'Female',
      ],
      departmentitems: [],
      items: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20],
      addressRules: [
        (v) => !!v || 'Address is required',
        (v) => (v && v.length <= 100) || 'address must be less than 100 characters',
        (v) => (v && v.length >= 10) || 'address must be greater than 10 characters',
      ],
      nameRules: [
        (v) => !!v || 'Name is required',
        (v) => (v && v.length <= 15) || 'Name must be less than 25 characters',
      ],
      emailRules: [
        (v) => !!v || 'E-mail is required',
        (v) => /.+@.+\..+/.test(v) || 'E-mail must be valid',
      ],
      countryRules: [
        (v) => !!v || 'Country name is required',
        (v) => (v && v.length <= 15) || 'Country Name must be less than 15 char',
      ],
      cityRules: [
        (v) => !!v || 'City name is required',
        (v) => (v && v.length <= 15) || 'Country Name must be less than 15 char',
      ],
      mobileRules: [
        (v) => !!v || 'Mobile number is required',
        (v) => (v && v.length === 10) || 'Mobile number must be 10 character',
      ],
      passwordRules: [
        (v) => !!v || 'Password is required',
        (v) => (v && v.length >= 5) || 'Password must have 5+ characters',
        (v) => /(?=.*[A-Z])/.test(v) || 'Must have one uppercase character',
        (v) => /(?=.*\d)/.test(v) || 'Must have one number',
        (v) => /([!@$%])/.test(v) || 'Must have one special character [!@#$%]',
      ],
      password2Rules: [
        (v) => !!v || 'Confirm Password is required',
        (v) => (v && this.password === this.password2) || 'password should be match',
      ],
      select: null,
    };
  },
  props: {
    employeecode: {
      type: String,
      required: true,
    },
    gender: {
      type: String,
      required: true,
    },
    department: {
      type: String,
      required: true,
    },
    DOB: {
      type: String,
      required: true,
    },
    firstname: {
      type: String,
      default: '',
      required: true,
    },
    lastname: {
      type: String,
      required: true,
    },
    address: {
      type: String,
      required: true,
    },
    city: {
      type: String,
      required: true,
    },
    country: {
      type: String,
      required: true,
    },
    email: {
      type: String,
      required: true,
    },
    mobilenumber: {
      type: String,
      required: true,
    },
    loading: {
      type: Boolean,
      required: false,
    },
    visible: {
      type: Boolean,
      default: true,
      required: false,
    },
    disabled: {
      type: Boolean,
      default: false,
    },
  },
  created() {
    getDepartmentList().then((value) => {
      this.departmentitems = value;
    });
  },
  mounted() {
  },
  methods: {
    validate() {
      if (this.$refs.form.validate()) {
        if (this.password !== '') {
          this.$emit('submit', this.password);
        } else {
          this.$emit('submit');
        }
      }
    },
    cancel() {
      this.$emit('cancel');
    },
  },

};
</script>

<style scoped>
.card {
  top: -20px;
}
</style>
